<template>
  <div class="add">
    <div class="header-description">
      <u-form :model="forms" ref="uForm" label-width="auto">
        <u-form-item label="标题" prop="title" required label-position="top">
          <u-input v-model="forms.title" placeholder="请输入标题(30字以内)" type="textarea" auto-height height="60" maxlength="30" />
        </u-form-item>

        <u-form-item label="公开类型" prop="status" required style="position: relative">
          <u-input v-model="forms.status" disabled placeholder="请选择公开类型" @click="showStstus = true" />

          <u-select v-model="showStstus" :list="$dict.getDict('realityStatus')" value-name="dictValue" label-name="dictName" @confirm="selectStatus"></u-select>

          <u-icon name="arrow-right" color="#CCCCCC" style="position: absolute; top: 25px; right: 30px"></u-icon>
        </u-form-item>

        <u-form-item label="发布地区" prop="areaId" required style="position: relative">
          <AiAreaPicker v-model="forms.areaId" :areaId="areaIdProps" @select="areaSelect"></AiAreaPicker>

          <u-icon name="arrow-right" color="#CCCCCC" style="position: absolute; top: 25px; right: 30px"></u-icon>
        </u-form-item>

        <u-form-item label="正文" prop="content" required label-position="top">
          <u-input v-model="forms.content" placeholder="请输入活动详情(30字以内)" type="textarea" auto-height height="60" maxlength="500" />
        </u-form-item>

        <u-form-item label="图片(最多9张)" prop="fileIds" class="avatars" label-position="top">
          <AiUploader :def.sync="forms.fileIds" multiple placeholder="上传图片" :limit="9"></AiUploader>
        </u-form-item>
      </u-form>
    </div>

    <div class="btn" @click="submit">保存</div>

    <AiBack></AiBack>
  </div>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'Add',
  components: {},
  props: {},
  data() {
    return {
      id: '',
      forms: {
        title: '',
        status: '',
        statusValue: '',
        content: '',
        fileIds: [],
        areaId: '',
      },
      showStstus: false,
      flag: false,
      areaIdProps: '',
    }
  },
  computed: { ...mapState(['user']) },
  onLoad(o) {
    console.log(o)
    this.id = o.id
    this.areaIdProps = this.user.areaId
    this.$dict.load('realityStatus').then(() => {
      this.getDetail()
    })
  },

  mounted() {},
  methods: {
    // getDetail() {
    //   this.$http.post(`/app/appvisitvondolence/queryDetailById?id=${this.id}`).then((res) => {
    //     if (res?.data) {
    //       this.forms = res.data
    //       this.forms.statusValue = res.data.status
    //       this.forms.status = this.$dict.getLabel('realityStatus', res.data.status)
    //       if (res.data.images) {
    //         this.forms.images = JSON.parse(res.data.images || '[]')
    //       }
    //     }
    //   })
    // },

    submit() {
      if (this.flag) return

      this.$refs.uForm.validate((valid) => {
        if (valid) {
          if (!this.forms.title) {
            return this.$u.toast('请输入标题')
          }
          if (!this.forms.content) {
            return this.$u.toast('请输入正文')
          }

          const imgs = []
          if (this.forms.fileIds) {
            this.forms.fileIds.map((e) => {
              imgs.push({ url: e.url, id: e.id })
            })
          }

          this.flag = true
          this.$http
            .post(`/app/appvisitvondolence/addOrUpdate`, {
              title: this.forms.title,
              status: this.forms.statusValue ? this.forms.statusValue : this.forms.status,
              areaId: this.forms.areaId,
              content: this.forms.content,
              // images: JSON.stringify(imgs) || [],
              images: imgs || [],
              id: this.id,
            })
            .then((res) => {
              if (res.code == 0) {
                this.$u.toast('发布成功')
                this.flag = false
                uni.navigateTo({ url: `./AppServicePublic` })
              }
            })
        } else {
          this.$u.toast('失败')
        }
      })
    },

    areaSelect(e) {
      this.forms.areaId = e.id
    },

    selectStatus(e) {
      this.forms.status = e[0].label
      this.forms.statusValue = e[0].value
    },
  },
}
</script>

<style lang="scss" scoped>
.add {
  height: 100%;
  padding-bottom: 112px;

  .header-description {
    ::v-deep .u-form {
      .u-form-item {
        .u-form-item__body {
          .u-form-item--right__content__slot {
            padding-bottom: 0;
          }
        }
      }

      .u-form-item:last-child {
        margin-bottom: 0;
        padding-bottom: 20px !important;
      }

      .avatars {
        .u-form-item__body {
          .default {
            width: 160px;
            height: 160px;
          }
        }
      }
    }
  }

  .btn {
    position: fixed;
    bottom: 0;
    width: 100%;
    height: 112px;
    line-height: 112px;
    background: #1365dd;
    text-align: center;
    font-size: 32px;
    font-weight: 500;
    color: #ffffff;
  }
}
</style>
